## ledmon 0.31

=== Makefile ===
#
#  Intel(R) Enclosure LED Utilities
#  Copyright (C) 2009,2011, Intel Corporation.
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms and conditions of the GNU General Public License,
#  version 2, as published by the Free Software Foundation.
#
#  This program is distributed in the hope it will be useful, but WITHOUT
#  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
#  more details.
#
#  You should have received a copy of the GNU General Public License along with
#  this program; if not, write to the Free Software Foundation, Inc., 
#  51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
#

# Installation directory
DESTDIR?=

.PHONY: ledmon ledctl man all

default: all

ledmon: 
	$(MAKE) -C src ledmon

ledctl:
	$(MAKE) -C src ledctl

man:
	$(MAKE) -C doc all

all: ledmon ledctl man

install: all
	$(MAKE) -C src DESTDIR=$(DESTDIR) install
	$(MAKE) -C doc DESTDIR=$(DESTDIR) install

uninstall:
	$(MAKE) -C src DESTDIR=$(DESTDIR) uninstall
	$(MAKE) -C doc DESTDIR=$(DESTDIR) uninstall

clean:
	$(MAKE) -C src clean
	$(MAKE) -C doc clean

mrproper: 
	$(MAKE) -C src mrproper
	$(MAKE) -C doc clean

TAGS_FILES=$(shell ls Makefile src/Makefile */*.[ch])
TAGS: $(TAGS_FILES)
	@etags $(TAGS_FILES)

=== doc/Makefile ===
#
#  Intel(R) Enclosure LED Utilities
#  Copyright (C) 2009,2011, Intel Corporation.
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms and conditions of the GNU General Public License,
#  version 2, as published by the Free Software Foundation.
#
#  This program is distributed in the hope it will be useful, but WITHOUT
#  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
#  more details.
#
#  You should have received a copy of the GNU General Public License along with
#  this program; if not, write to the Free Software Foundation, Inc., 
#  51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
#

# Installation directory
DESTDIR?=
MAN_INSTDIR=$(DESTDIR)/usr/share/man
MAN8_INSTDIR=$(MAN_INSTDIR)/man8
MAN5_INSTDIR=$(MAN_INSTDIR)/man5

RELEASE_DATE?="January 2012"
RELEASE_VER?=0.31

default: all

ledctl.conf.5.gz: ledctl.conf.pod
	pod2man -r "LEDCTL.CONF Version $(RELEASE_VER)" -d $(RELEASE_DATE) \
		-s 5 -n ledctl.conf -c "Inter(R) Enclosure LED Utilities Config" $< | gzip -9f > $@

ledmon.8.gz: ledmon.pod
	pod2man -r "LEDMON Version $(RELEASE_VER)" -d $(RELEASE_DATE) \
		-s 8 -n ledmon -c "Intel(R) Enclosure LED Monitor Service" $< | gzip -9f > $@

ledctl.8.gz: ledctl.pod
	pod2man -r "LEDCTL Version $(RELEASE_VER)" -d $(RELEASE_DATE) \
		-s 8 -n ledctl -c "Intel(R) Enclosure LED Control Application" $< | gzip -9f > $@	

install: all
	install -D -m 644 ./ledmon.8.gz $(MAN8_INSTDIR)/ledmon.8.gz
	install -D -m 644 ./ledctl.8.gz $(MAN8_INSTDIR)/ledctl.8.gz
	install -D -m 644 ./ledctl.conf.5.gz $(MAN5_INSTDIR)/ledctl.conf.5.gz

uninstall:
	rm -f $(MAN8_INSTDIR)/ledmon.8.gz $(MAN8_INSTDIR)/ledctl.8.gz
	rm -f $(MAN5_INSTDIR)/ledctl.conf.5.gz

all: ledctl.conf.5.gz ledmon.8.gz ledctl.8.gz

clean:
	rm -f ledmon.8 ledmon.8.gz ledctl.8 ledctl.8.gz
	rm -f ledctl.conf.5 ledctl.conf.5.gz

=== src/Makefile ===
#
#  Intel(R) Enclosure LED Utilities
#  Copyright (C) 2009,2011, Intel Corporation.
#
#  This program is free software; you can redistribute it and/or modify it
#  under the terms and conditions of the GNU General Public License,
#  version 2, as published by the Free Software Foundation.
#
#  This program is distributed in the hope it will be useful, but WITHOUT
#  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
#  more details.
#
#  You should have received a copy of the GNU General Public License along with
#  this program; if not, write to the Free Software Foundation, Inc., 
#  51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
#

# Installation directory prefix.
DESTDIR?=

# Installation directory of ledctl application.
LEDCTL_INSTDIR=$(DESTDIR)/usr/sbin

# Installation directory of ledmon application.
LEDMON_INSTDIR=$(DESTDIR)/usr/sbin

# Output directory for object files.
OUTDIR?=$(shell pwd)/_build

# Build components common to both of applications.
OBJECTS=\
	$(OUTDIR)/ahci.o	\
	$(OUTDIR)/block.o	\
	$(OUTDIR)/cntrl.o	\
	$(OUTDIR)/enclosure.o	\
	$(OUTDIR)/list.o	\
	$(OUTDIR)/raid.o	\
	$(OUTDIR)/scsi.o	\
	$(OUTDIR)/slave.o	\
	$(OUTDIR)/status.o	\
	$(OUTDIR)/sysfs.o	\
	$(OUTDIR)/smp.o		\
	$(OUTDIR)/dellssd.o	\
	$(OUTDIR)/utils.o

# Build components of ledmon application.
LEDMON_OBJECTS=\
	$(OUTDIR)/ledmon.o  	\
	$(OUTDIR)/pidfile.o	\
	$(OBJECTS)

# Build components of ledctl application.
LEDCTL_OBJECTS=\
	$(OUTDIR)/ledctl.o	\
	$(OBJECTS)

CFLAGS=-O0 -g -Wall -std=c99
DEFFLAGS=-D_DEBUG -D_GNU_SOURCE -D_BSD_SOURCE -DDMALLOC_DISABLE
INCFLAGS=-I../config
LDFLAGS=-O0 -g $(DEFFLAGS)

SOURCES:=$(shell find -name "*.[cC]" -print)

default: all

ledmon: $(OUTDIR)/.depend $(LEDMON_OBJECTS)
	$(CC) $(LDFLAGS) $(LDLIBS) $(LEDMON_OBJECTS) -o $@

ledctl: $(OUTDIR)/.depend $(LEDCTL_OBJECTS)
	$(CC) $(LDFLAGS) $(LDLIBS) $(LEDCTL_OBJECTS) -o $@

$(OUTDIR)/%.o: %.c
	$(CC) $(CFLAGS) $(DEFFLAGS) $(INCFLAGS) -c $< -o $@

all: $(OUTDIR)/.depend ledmon ledctl

uninstall:
	rm -f $(LEDMON_INSTDIR)/ledmon
	rm -f $(LEDCTL_INSTDIR)/ledctl

install: all
	install -D ./ledmon $(LEDMON_INSTDIR)/ledmon
	install -D ./ledctl $(LEDCTL_INSTDIR)/ledctl

clean:
	rm -rf $(OUTDIR)

depend dep: $(OUTDIR)/.depend

mrproper: clean
	rm -f ledmon ledctl

$(OUTDIR)/.depend: $(SOURCES)
	mkdir -p $(OUTDIR)
	$(CC) $(CFLAGS) $(DEFFLAGS) $(INCFLAGS) -M $^ | sed 's/^[a-z,0-9]/$(subst /,\/,$(OUTDIR))\/&/' > $(OUTDIR)/.depend

ifeq ($(filter install uninstall depend clean mrproper,$(MAKECMDGOALS)),)
    -include $(OUTDIR)/.depend
endif

=== debian/changelog ===
ledmon (0.31-1) unstable; urgency=low

  * Initial release (Closes: #658815)

 -- Daniel Jared Dominguez <Jared_Dominguez@Dell.com>  Mon, 23 Jan 2012 13:45:41 -0600

=== debian/control ===
Source: ledmon
Section: admin
Priority: extra
Maintainer: Daniel Jared Dominguez <Jared_Dominguez@Dell.com>
Build-Depends: debhelper (>= 7.0.50~), perl
Standards-Version: 3.9.2
Homepage: http://ledmon.sourceforge.net/ 

Package: ledmon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openipmi
Description: Enclosure LED Utilities
 ledmon and ledctl are userspace tools designed to control storage
 enclosure LEDs. The user must have root privileges to use these tools.
 .
 These tools use the SGPIO and SES-2 protocols to monitor and control LEDs.
 They been verified to work with Intel(R) storage controllers (i.e. the
 Intel(R) AHCI controller) and have not been tested with storage controllers of
 other vendors (especially SAS/SCSI controllers).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

clean:
	$(MAKE) mrproper
	dh_clean

%:
	dh $@

## ledmon 0.32

=== doc/Makefile ===
--- 
+++ 
@@ -22,8 +22,8 @@
 MAN8_INSTDIR=$(MAN_INSTDIR)/man8
 MAN5_INSTDIR=$(MAN_INSTDIR)/man5
 
-RELEASE_DATE?="January 2012"
-RELEASE_VER?=0.31
+RELEASE_DATE?="February 2012"
+RELEASE_VER?=0.32
 
 default: all

=== debian/changelog ===
ledmon (0.32-1) unstable; urgency=low

  * New upstream release
  * Fixes issue where HOTSPARE had higher priority than REBUILD

 -- Daniel Jared Dominguez <Jared_Dominguez@Dell.com>  Mon, 05 Mar 2012 11:41:06 -0600

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: admin
 Priority: extra
 Maintainer: Daniel Jared Dominguez <Jared_Dominguez@Dell.com>
-Build-Depends: debhelper (>= 7.0.50~), perl
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 8), perl
+Standards-Version: 3.9.1
 Homepage: http://ledmon.sourceforge.net/ 
 
 Package: ledmon

## ledmon 0.74

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 #  Intel(R) Enclosure LED Utilities
-#  Copyright (C) 2009,2011, Intel Corporation.
+#  Copyright (C) 2009,2011,2012, Intel Corporation.
 #
 #  This program is free software; you can redistribute it and/or modify it
 #  under the terms and conditions of the GNU General Public License,

=== doc/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 #  Intel(R) Enclosure LED Utilities
-#  Copyright (C) 2009,2011, Intel Corporation.
+#  Copyright (C) 2009,2011,2012, Intel Corporation.
 #
 #  This program is free software; you can redistribute it and/or modify it
 #  under the terms and conditions of the GNU General Public License,
@@ -22,8 +22,8 @@
 MAN8_INSTDIR=$(MAN_INSTDIR)/man8
 MAN5_INSTDIR=$(MAN_INSTDIR)/man5
 
-RELEASE_DATE?="February 2012"
-RELEASE_VER?=0.32
+RELEASE_DATE?="August 2012"
+RELEASE_VER?=0.74
 
 default: all

=== src/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 #  Intel(R) Enclosure LED Utilities
-#  Copyright (C) 2009,2011, Intel Corporation.
+#  Copyright (C) 2009,2012, Intel Corporation.
 #
 #  This program is free software; you can redistribute it and/or modify it
 #  under the terms and conditions of the GNU General Public License,
@@ -58,7 +58,7 @@
 CFLAGS=-O0 -g -Wall -std=c99
 DEFFLAGS=-D_DEBUG -D_GNU_SOURCE -D_BSD_SOURCE -DDMALLOC_DISABLE
 INCFLAGS=-I../config
-LDFLAGS=-O0 -g $(DEFFLAGS)
+LDFLAGS=-O0 -g $(DEFFLAGS) -lsgutils2
 
 SOURCES:=$(shell find -name "*.[cC]" -print)

=== debian/changelog ===
ledmon (0.74-1~ubuntu12.10.1) quantal-backports; urgency=low

  * No-change backport to quantal (LP: #1074455)

 -- Felix Geyer <debfx@ubuntu.com>  Sun, 28 Apr 2013 18:33:19 +0200

ledmon (0.74-1) unstable; urgency=low

  * New upstream release:
  * restart of the ledmon's internal state when an unrecoverable error occurs
    (e.g. lack of disk's location)
  * logging level for not supported patterns changed from 'warning' to 'debug'
  * more detailed information about device change (name changed, missing)
  * added extra checks against device presence in sysfs (device may disappear
    at anytime: during rescan, initialization, sending command)
  * pattern "locate_off" fixed
  * SES-2 support for enclosures
  * New patterns (SES-2) in ledctl for drives in enclosures
  * Improved LED blinking and slot locations for AHCI and SCSI DA
  * ledctl and ledmon were converted to the raw bitstream (TX_GP) interface,
    so they do not need additional SGPIO support in the kernel now
    (by Dan Williams <dan.j.williams@intel.com>)
  * the way ledctl works has been changed: so far turning on some LEDs
    did not change the state of all other LEDs of all controllers,
    now turning on some LEDs turns off all other LEDs of all controllers
  * ledctl's manual was corrected and updated

 -- Daniel Jared Dominguez <Jared_Dominguez@Dell.com>  Thu, 23 Aug 2012 16:28:32 -0500

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: ledmon
 Section: admin
-Priority: extra
+Priority: optional
 Maintainer: Daniel Jared Dominguez <Jared_Dominguez@Dell.com>
-Build-Depends: debhelper (>= 8), perl
-Standards-Version: 3.9.1
+Build-Depends: debhelper (>= 9), perl, libsgutils2-dev
+Standards-Version: 3.9.3
 Homepage: http://ledmon.sourceforge.net/ 
 
 Package: ledmon
@@ -17,3 +17,6 @@
  They been verified to work with Intel(R) storage controllers (i.e. the
  Intel(R) AHCI controller) and have not been tested with storage controllers of
  other vendors (especially SAS/SCSI controllers).
+ .
+ For backplane enclosures attached to ISCI controllers, support is limited to
+ Intel(R) Intelligent Backplanes.

## ledmon 0.79

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 #  Intel(R) Enclosure LED Utilities
-#  Copyright (C) 2009,2011,2012, Intel Corporation.
+#  Copyright (C) 2009-2013 Intel Corporation.
 #
 #  This program is free software; you can redistribute it and/or modify it
 #  under the terms and conditions of the GNU General Public License,

=== doc/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 #  Intel(R) Enclosure LED Utilities
-#  Copyright (C) 2009,2011,2012, Intel Corporation.
+#  Copyright (C) 2009-2013 Intel Corporation.
 #
 #  This program is free software; you can redistribute it and/or modify it
 #  under the terms and conditions of the GNU General Public License,
@@ -22,8 +22,8 @@
 MAN8_INSTDIR=$(MAN_INSTDIR)/man8
 MAN5_INSTDIR=$(MAN_INSTDIR)/man5
 
-RELEASE_DATE?="August 2012"
-RELEASE_VER?=0.74
+RELEASE_DATE?="November 2013"
+RELEASE_VER?=0.79
 
 default: all

=== src/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 #  Intel(R) Enclosure LED Utilities
-#  Copyright (C) 2009,2012, Intel Corporation.
+#  Copyright (C) 2009-2013 Intel Corporation.
 #
 #  This program is free software; you can redistribute it and/or modify it
 #  under the terms and conditions of the GNU General Public License,
@@ -12,7 +12,7 @@
 #  more details.
 #
 #  You should have received a copy of the GNU General Public License along with
-#  this program; if not, write to the Free Software Foundation, Inc., 
+#  this program; if not, write to the Free Software Foundation, Inc.,
 #  51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
 #
 
@@ -55,7 +55,7 @@
 	$(OUTDIR)/ledctl.o	\
 	$(OBJECTS)
 
-CFLAGS=-O0 -g -Wall -std=c99
+CFLAGS=-O0 -g -Wall
 DEFFLAGS=-D_DEBUG -D_GNU_SOURCE -D_BSD_SOURCE -DDMALLOC_DISABLE
 INCFLAGS=-I../config
 LDFLAGS=-O0 -g $(DEFFLAGS) -lsgutils2

=== debian/changelog ===
ledmon (0.79-2build1) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:31:42 +0000

ledmon (0.79-2) unstable; urgency=high

  * Fix for 3.13 kernel change (LP: #1349920)

 -- Daniel Jared Dominguez <Jared_Dominguez@Dell.com>  Wed, 30 Jul 2014 14:19:11 -0500

ledmon (0.79-1) unstable; urgency=medium

  * Acknowledge NMUs. (Closes: #708673)
  * Putting all this into git.
  * Add VCS information to debian/control.

 -- Daniel Jared Dominguez <Jared_Dominguez@Dell.com>  Wed, 25 Jun 2014 16:44:07 -0500

ledmon (0.79-0.2) unstable; urgency=low

  * Non-maintainer upload.
  * Fix FTBFS on non-Linux  with "Architecture: linux-any"

 -- Kamal Mostafa <kamal@debian.org>  Tue, 03 Dec 2013 07:16:30 -0800

ledmon (0.79-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release.
  * Adds support for NVME SSD devices (uses nvme/nvmhci block driver). 
  * Fix small coding error in ledctl.pod
  * Update help info regarding reporting bugs
  * Make sure addr is null-terminated
  * Check if the directory 'holders' exists
  * Check device for NULL before dereferencing
  * ledctl documentation improvements
  * Do not use ISO C99 standard
  * Do not send LED command if state of block device has not changed
  * Change ledmon's behavior during rebuild. 
  * Correct some style problems using kernel's checkpatch.
  * Remove indentation info
  * Correct indentation according to the Linux coding style using indent
  * Update Copyright year to 2013
  * Fix support for Dell PCIe SSD Devices
  * More minor fixes revealed by a coverity scan
  * Minor fixes revealed by a coverity scan

 -- Kent Baxley <kb4xley@gmail.com>  Wed, 27 Nov 2013 15:33:27 -0600

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,16 @@
 Source: ledmon
 Section: admin
 Priority: optional
-Maintainer: Daniel Jared Dominguez <Jared_Dominguez@Dell.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Daniel Jared Dominguez <Jared_Dominguez@Dell.com>
 Build-Depends: debhelper (>= 9), perl, libsgutils2-dev
-Standards-Version: 3.9.3
-Homepage: http://ledmon.sourceforge.net/ 
+Standards-Version: 3.9.5
+Homepage: http://ledmon.sourceforge.net/
+Vcs-Git: git://linux.dell.com/debian/ledmon.git
+Vcs-Browser: http://linux.dell.com/git/debian/ledmon.git
 
 Package: ledmon
-Architecture: any
+Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}, openipmi
 Description: Enclosure LED Utilities
  ledmon and ledctl are userspace tools designed to control storage

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v

clean:
	$(MAKE) mrproper
	dh_clean

%:
	dh $@

=== debian/watch ===
# watch control file for uscan
version=3
http://sf.net/ledmon/ledmon-(.+)\.tar\.gz debian uupdate

## ledmon 0.90

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 #  Intel(R) Enclosure LED Utilities
-#  Copyright (C) 2009-2013 Intel Corporation.
+#  Copyright (C) 2009-2017 Intel Corporation.
 #
 #  This program is free software; you can redistribute it and/or modify it
 #  under the terms and conditions of the GNU General Public License,

=== doc/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 #  Intel(R) Enclosure LED Utilities
-#  Copyright (C) 2009-2013 Intel Corporation.
+#  Copyright (C) 2009-2017 Intel Corporation.
 #
 #  This program is free software; you can redistribute it and/or modify it
 #  under the terms and conditions of the GNU General Public License,
@@ -22,14 +22,14 @@
 MAN8_INSTDIR=$(MAN_INSTDIR)/man8
 MAN5_INSTDIR=$(MAN_INSTDIR)/man5
 
-RELEASE_DATE?="November 2013"
-RELEASE_VER?=0.79
+RELEASE_DATE?="February 2018"
+RELEASE_VER?=0.90
 
 default: all
 
-ledctl.conf.5.gz: ledctl.conf.pod
-	pod2man -r "LEDCTL.CONF Version $(RELEASE_VER)" -d $(RELEASE_DATE) \
-		-s 5 -n ledctl.conf -c "Inter(R) Enclosure LED Utilities Config" $< | gzip -9f > $@
+ledmon.conf.5.gz: ledmon.conf.pod
+	pod2man -r "LEDMON.CONF Version $(RELEASE_VER)" -d $(RELEASE_DATE) \
+		-s 5 -n ledmon.conf -c "Intel(R) Enclosure LED Utilities Config" $< | gzip -9f > $@
 
 ledmon.8.gz: ledmon.pod
 	pod2man -r "LEDMON Version $(RELEASE_VER)" -d $(RELEASE_DATE) \
@@ -42,14 +42,14 @@
 install: all
 	install -D -m 644 ./ledmon.8.gz $(MAN8_INSTDIR)/ledmon.8.gz
 	install -D -m 644 ./ledctl.8.gz $(MAN8_INSTDIR)/ledctl.8.gz
-	install -D -m 644 ./ledctl.conf.5.gz $(MAN5_INSTDIR)/ledctl.conf.5.gz
+	install -D -m 644 ./ledmon.conf.5.gz $(MAN5_INSTDIR)/ledmon.conf.5.gz
 
 uninstall:
 	rm -f $(MAN8_INSTDIR)/ledmon.8.gz $(MAN8_INSTDIR)/ledctl.8.gz
-	rm -f $(MAN5_INSTDIR)/ledctl.conf.5.gz
+	rm -f $(MAN5_INSTDIR)/ledmon.conf.5.gz
 
-all: ledctl.conf.5.gz ledmon.8.gz ledctl.8.gz
+all: ledmon.conf.5.gz ledmon.8.gz ledctl.8.gz
 
 clean:
 	rm -f ledmon.8 ledmon.8.gz ledctl.8 ledctl.8.gz
-	rm -f ledctl.conf.5 ledctl.conf.5.gz
+	rm -f ledmon.conf.5 ledmon.conf.5.gz

=== src/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 #  Intel(R) Enclosure LED Utilities
-#  Copyright (C) 2009-2013 Intel Corporation.
+#  Copyright (C) 2009-2017 Intel Corporation.
 #
 #  This program is free software; you can redistribute it and/or modify it
 #  under the terms and conditions of the GNU General Public License,
@@ -33,6 +33,7 @@
 	$(OUTDIR)/ahci.o	\
 	$(OUTDIR)/block.o	\
 	$(OUTDIR)/cntrl.o	\
+	$(OUTDIR)/config_file.o	\
 	$(OUTDIR)/enclosure.o	\
 	$(OUTDIR)/list.o	\
 	$(OUTDIR)/raid.o	\
@@ -42,7 +43,10 @@
 	$(OUTDIR)/sysfs.o	\
 	$(OUTDIR)/smp.o		\
 	$(OUTDIR)/dellssd.o	\
-	$(OUTDIR)/utils.o
+	$(OUTDIR)/utils.o	\
+	$(OUTDIR)/pci_slot.o	\
+        $(OUTDIR)/vmdssd.o      \
+        $(OUTDIR)/udev.o
 
 # Build components of ledmon application.
 LEDMON_OBJECTS=\
@@ -55,23 +59,42 @@
 	$(OUTDIR)/ledctl.o	\
 	$(OBJECTS)
 
-CFLAGS=-O0 -g -Wall
-DEFFLAGS=-D_DEBUG -D_GNU_SOURCE -D_BSD_SOURCE -DDMALLOC_DISABLE
-INCFLAGS=-I../config
-LDFLAGS=-O0 -g $(DEFFLAGS) -lsgutils2
+TEST_CONFIG_OBJECTS=\
+	$(OUTDIR)/config_file.o	\
+	$(OUTDIR)/list.o	\
+	$(OUTDIR)/utils.o
+
+CXFLAGS=-O0 -g -std=gnu99
+CWFLAGS=-Wall
+CFLAGS=$(CXFLAGS) $(CWFLAGS)
+
+DEFFLAGS=-D_DEBUG -D_GNU_SOURCE -D_DEFAULT_SOURCE -DDMALLOC_DISABLE
+CPPFLAGS=$(DEFFLAGS)
+ALL_CPPFLAGS=$(CPPFLAGS) -I../config
+
+LDFLAGS=$(CXFLAGS)
+LDLIBS=-lsgutils2 -ludev
 
 SOURCES:=$(shell find -name "*.[cC]" -print)
 
 default: all
 
+ifdef DEBUG_IBPI
+CPPFLAGS += -DDEBUG_IBPI
+endif
+
 ledmon: $(OUTDIR)/.depend $(LEDMON_OBJECTS)
-	$(CC) $(LDFLAGS) $(LDLIBS) $(LEDMON_OBJECTS) -o $@
+	$(CC) $(LDFLAGS) $(LEDMON_OBJECTS) $(LDLIBS) -o $@
 
 ledctl: $(OUTDIR)/.depend $(LEDCTL_OBJECTS)
-	$(CC) $(LDFLAGS) $(LDLIBS) $(LEDCTL_OBJECTS) -o $@
+	$(CC) $(LDFLAGS) $(LEDCTL_OBJECTS) $(LDLIBS) -o $@
+
+test_config: ALL_CPPFLAGS += -D_TEST_CONFIG
+test_config: $(OUTDIR)/.depend $(TEST_CONFIG_OBJECTS)
+	$(CC) $(LDFLAGS) $(TEST_CONFIG_OBJECTS) $(LDLIBS) -o $@
 
 $(OUTDIR)/%.o: %.c
-	$(CC) $(CFLAGS) $(DEFFLAGS) $(INCFLAGS) -c $< -o $@
+	$(CC) $(CFLAGS) $(ALL_CPPFLAGS) -c $< -o $@
 
 all: $(OUTDIR)/.depend ledmon ledctl
 
@@ -93,7 +116,7 @@
 
 $(OUTDIR)/.depend: $(SOURCES)
 	mkdir -p $(OUTDIR)
-	$(CC) $(CFLAGS) $(DEFFLAGS) $(INCFLAGS) -M $^ | sed 's/^[a-z,0-9]/$(subst /,\/,$(OUTDIR))\/&/' > $(OUTDIR)/.depend
+	$(CC) $(CFLAGS) $(ALL_CPPFLAGS) -M $^ | sed 's/^[a-z,0-9]/$(subst /,\/,$(OUTDIR))\/&/' > $(OUTDIR)/.depend
 
 ifeq ($(filter install uninstall depend clean mrproper,$(MAKECMDGOALS)),)
     -include $(OUTDIR)/.depend

=== debian/changelog ===
ledmon (0.90-0ubuntu1~18.04.1) bionic; urgency=medium

  * Backport ledmon 0.90-0ubuntu1 to Ubuntu 18.04. (LP: #1789786)

 -- Woodrow Shen (Shye-Tzeng Shen) <woodrow.shen@canonical.com>  Fri, 21 Sep 2018 13:52:12 +0200

ledmon (0.90-0ubuntu1) cosmic; urgency=medium

  * New upstream release
  * Drop upstream cherrypick
  * Refresh patches
  * Bump standards version

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 01 Aug 2018 10:59:20 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Daniel Jared Dominguez <Jared_Dominguez@Dell.com>
-Build-Depends: debhelper (>= 9), perl, libsgutils2-dev
-Standards-Version: 3.9.5
+Build-Depends: debhelper (>= 9), perl, libsgutils2-dev, libudev-dev
+Standards-Version: 4.1.5
 Homepage: http://ledmon.sourceforge.net/
 Vcs-Git: git://linux.dell.com/debian/ledmon.git
 Vcs-Browser: http://linux.dell.com/git/debian/ledmon.git

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ledmon-$1.tar.gz%" \
     https://github.com/intel/ledmon/tags \
     (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## ledmon 0.93

=== debian/changelog ===
ledmon (0.93-2) unstable; urgency=medium

  * Don't compile with flag address-of-packed-member to fix build failure.

 -- Hsieh-Tseng Shen <woodrow.shen@gmail.com>  Mon, 02 Dec 2019 03:52:31 +0000

ledmon (0.93-1) unstable; urgency=medium

  * Salvage ledmon for maintenance transition. (Closes: #939315)
  * New upstream release v0.93.
  * Remove obsolete patches.
  * Add debian/watch for importing upstream as tarball.

 -- Hsieh-Tseng Shen <woodrow.shen@gmail.com>  Tue, 05 Nov 2019 09:03:43 +0000

ledmon (0.90-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release. (Closes: #878271)
    - Fixes FTBFS with glibc 2.28. (Closes: #915476)

 -- Adrian Bunk <bunk@debian.org>  Fri, 11 Jan 2019 14:03:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: ledmon
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Daniel Jared Dominguez <Jared_Dominguez@Dell.com>
-Build-Depends: debhelper (>= 9), perl, libsgutils2-dev, libudev-dev
-Standards-Version: 4.1.5
-Homepage: http://ledmon.sourceforge.net/
-Vcs-Git: git://linux.dell.com/debian/ledmon.git
-Vcs-Browser: http://linux.dell.com/git/debian/ledmon.git
+Maintainer: Hsieh-Tseng Shen <woodrow.shen@gmail.com>
+Build-Depends: debhelper (>= 9.20160403~), perl, libsgutils2-dev, libudev-dev
+Standards-Version: 4.4.0
+Homepage: https://github.com/intel/ledmon
+Vcs-Git: https://salsa.debian.org/woodrow.shen-guest/ledmon.git
+Vcs-Browser: https://salsa.debian.org/woodrow.shen-guest/ledmon
 
 Package: ledmon
 Architecture: linux-any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export LC_ALL := C.UTF-8

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- \
		--enable-systemd

override_dh_installman:
	# rename manpages file for fixing lintian warnings
	mv debian/ledmon/usr/share/man/man5/ledmon.conf.5.5 debian/ledmon/usr/share/man/man5/ledmon.conf.5
	mv debian/ledmon/usr/share/man/man8/ledctl.8.8 debian/ledmon/usr/share/man/man8/ledctl.8
	mv debian/ledmon/usr/share/man/man8/ledmon.8.8 debian/ledmon/usr/share/man/man8/ledmon.8
	dh_installman

## ledmon 0.94

=== debian/changelog ===
ledmon (0.94-1) unstable; urgency=medium

  * New upstream release 0.94.
    - Support for AMD IPMI enclosure management.
    - Support for NPEM.
  * debian/control: add systemd, pkg-config and libpci-dev as build dependency.
  * debian/control: update Standards-Version to 4.5.0.
  * Add debian/ledmon.init.
  * debian/rules: fix typo and remove manual systemd installation.
  * Remove obsolete patch.

 -- Hsieh-Tseng Shen <woodrow.shen@gmail.com>  Thu, 13 Feb 2020 05:55:32 +0000

ledmon (0.93-3) unstable; urgency=medium

  * Fix 32bit compilation error to prevent shift-count-overflow.

 -- Hsieh-Tseng Shen <woodrow.shen@gmail.com>  Tue, 10 Dec 2019 05:34:46 +0000

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,11 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export LC_ALL := C.UTF-8
 
 %:
-	dh $@ --with autoreconf
+	dh $@ --with systemd
 
 override_dh_auto_configure:
 	dh_auto_configure -- \

## ledmon 0.95

=== debian/changelog ===
ledmon (0.95-2) unstable; urgency=medium

  * Rebuild with libsgutils2-2 to fix broken dependency. (Closes: #994521)

 -- Hsieh-Tseng Shen <woodrow.shen@gmail.com>  Thu, 17 Feb 2022 23:40:25 +0800

ledmon (0.95-1) unstable; urgency=medium

  * New upstream release 0.95.
    - Allow to run ledctl version without root.
    - README update with the compilation steps.
  * debian/copyright: update date.
  * debian/docs: rename README.md.
  * debian/rules: remove unnecessary '--with systemd' and override_dh_installman.

 -- Hsieh-Tseng Shen <woodrow.shen@gmail.com>  Sat, 23 Jan 2021 21:15:31 +0800

ledmon (0.94-2) unstable; urgency=medium

  * Rebuild with libsgutils2-2 to fix broken dependency. (Closes: #957088)
  * debian/copyright: add Upstream-Contact to fix lintian warning.

 -- Hsieh-Tseng Shen <woodrow.shen@gmail.com>  Sun, 19 Apr 2020 10:00:41 +0000

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: admin
 Priority: optional
 Maintainer: Hsieh-Tseng Shen <woodrow.shen@gmail.com>
-Build-Depends: debhelper (>= 9.20160403~), perl, libsgutils2-dev, libudev-dev
-Standards-Version: 4.4.0
+Build-Depends: debhelper (>= 10), systemd, pkg-config, libsgutils2-dev, libudev-dev, libpci-dev
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
+Vcs-Git: https://salsa.debian.org/debian/ledmon.git
+Vcs-Browser: https://salsa.debian.org/debian/ledmon
 Homepage: https://github.com/intel/ledmon
-Vcs-Git: https://salsa.debian.org/woodrow.shen-guest/ledmon.git
-Vcs-Browser: https://salsa.debian.org/woodrow.shen-guest/ledmon
 
 Package: ledmon
 Architecture: linux-any

=== debian/watch ===
# watch control file for uscan
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/ledmon-$1\.tar\.gz/ \
  https://github.com/intel/ledmon/tags .*/v?(\d\S+)\.tar\.gz

## ledmon 0.97

=== debian/changelog ===
ledmon (0.97-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply adapted upstream commit to fix FTBFS on 32-bit arches.
    Thanks to Guillem Jover <gjover@sipwise.com> (Closes: #1077904)

 -- Michael Prokop <mika@debian.org>  Mon, 07 Oct 2024 13:01:52 +0200

ledmon (0.97-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Replace systemd Build-Depends with systemd-dev. (Closes: #1060587)

 -- Michael Biebl <biebl@debian.org>  Wed, 17 Jul 2024 16:29:18 +0200

ledmon (0.97-1) unstable; urgency=medium

  * New upstream release 0.97.
    - ledctl: add support to empty slots blinking.
    - ledmon license change to LGPLv2.
    - ledctl: Add SES get/set/list slot support.
    - Update NPEM wait command.
    - Remove exclusionary language.
    - ledmon: Define ONESHOT_NORMAL for VMD.
    - more bug fixes from 0.97 and 0.96.
  * debian/copyright: update license and date.

 -- Hsieh-Tseng Shen <woodrow.shen@gmail.com>  Tue, 27 Feb 2024 23:20:44 +0800

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: admin
 Priority: optional
 Maintainer: Hsieh-Tseng Shen <woodrow.shen@gmail.com>
-Build-Depends: debhelper (>= 10), systemd, pkg-config, libsgutils2-dev, libudev-dev, libpci-dev
-Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 13), systemd-dev, pkg-config, libsgutils2-dev, libudev-dev, libpci-dev
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian/ledmon.git
 Vcs-Browser: https://salsa.debian.org/debian/ledmon

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export LC_ALL := C.UTF-8

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		--enable-systemd
